class calculationdata{
  static int mixnum;
  static treelk *ff;
  static const long double *x;
  static const int *trueparnums;
  static int conv;
  calculationdata(){};
  //Calculated Data
  static long double* loglike;
  static long double* tp;
  static long double* extp;
  static long double* tst;
  //  static long double* bl;
  static long double* bst;
  static long double* mxpr;
  static long double* sl;
  static long double* spp;
  static const int* vars;
  static const int* tvn;
  static Realmatrix oi;
  static Realmatrix oii;
public:
  static void setup(int mn,treelk *tr,const long double *ps,const int *pn,int c,const int *vs=NULL){mixnum=mn;ff=tr;x=ps;trueparnums=pn;conv=c;loglike=NULL;tp=NULL;extp=NULL;tst=NULL;bst=NULL;mxpr=NULL;sl=NULL;spp=NULL;vars=vs;tvn=vs;};
  static const long double *LL();
  static const int *varsel();
  static const int *converge();
  static const int *varnum();
  static const int *truevarnum();
  static const long double *coeff();
  static const long double *expcoeff();
  static const long double *tstat();
  static const int *branchno();
  static const int *branchtop();
  static const int *branchbot();
  static const long double *branchlen();
  static const long double *branchlenstd();
  static void tree(ostream& out);
  static void treestd(ostream& out);
  static const int *mixno();
  static const long double *mixprob();
  static const int *siteno();
  static const long double *sitelike();
  static const long double *sitepostprob();
  static void observedinformation(ostream& out);
  static void observedinformationinverse(ostream& out);
};

int calculationdata::mixnum;
treelk *calculationdata::ff;
const long double *calculationdata::x;
const int *calculationdata::trueparnums;
int calculationdata::conv;
long double* calculationdata::loglike;
long double* calculationdata::tp;
long double* calculationdata::extp;
long double* calculationdata::tst;
long double* calculationdata::bst;
long double* calculationdata::mxpr;
long double* calculationdata::sl;
long double* calculationdata::spp;
const int* calculationdata::vars;
const int* calculationdata::tvn;
Realmatrix calculationdata::oi;
Realmatrix calculationdata::oii;


const long double *calculationdata::LL(){
  if(loglike==NULL){
    loglike=new long double;
    if(oi.sz==0){
      *loglike=ff->quickEvaluate(x);
    }else{
      *loglike=ff->evaluate(x);
    };
  };
  return loglike;
};

const int *calculationdata::varsel(){
  //  if(vs==NULL){
  //  };
  return vars;
};

const int *calculationdata::converge(){
  return &conv;
};

const int *calculationdata::varnum(){
  return NULL;
};

const int *calculationdata::branchno(){
  return NULL;
};

const int *calculationdata::truevarnum(){
  return vars;
};

const long double *calculationdata::coeff(){
  if(tp==NULL){
    tp=ff->truepars();
  };
  return tp;
};

const long double *calculationdata::expcoeff(){
  if(extp==NULL){
    extp=new long double[params::numpars*mixnum];
    if(tp==NULL){
      tp=ff->truepars();
    };
    for(int i=0;i<params::numpars*mixnum;i++){
      *(extp+i)=exp(*(tp+i));
    };
  };
  return extp;
};

const long double *calculationdata::tstat(){
  if(tst==NULL){
    tst=ff->tstats(x);
  };
  return tst;
};

const int* calculationdata::branchtop(){
  return NULL;
};

const int* calculationdata::branchbot(){
  return NULL;
};

const long double *calculationdata::branchlen(){
  return ff->branchlen();
};

const long double *calculationdata::branchlenstd(){
  if(bst==NULL){
    if(oii.sz==0){//Need to calculate oii
      if(oi.sz==0){ 
	oi=ff->oi(x);
      };
      oii=oi.inverse();
    };
    bst=new long double[ff->edges()];
    for(int i=0;i<ff->edges();i++){
      *(bst+i)=*(oi.entries+i*(oi.sz+1));
    };
  };
  return bst;
};

void calculationdata::tree(ostream& out){
  ff->printtree(out);
};

void calculationdata::treestd(ostream& out){
  if(oii.sz==0){//Need to calculate oii
    if(oi.sz==0){ 
      oi=ff->oi(x);
    };
    oii=oi.inverse();
  };
  ff->printtreedev(oii,out);
};

const int *calculationdata::mixno(){
  return NULL;
};

const long double *calculationdata::mixprob(){
  if(mixnum<2){
    return NULL;
  }else{
    return ((Mixtreelikelihood *)ff)->getmixprobs();
  };
};

const int *calculationdata::siteno(){
  return NULL;
};

const long double *calculationdata::sitelike(){
  if(sl==NULL){
    sl=ff->sitelikes();
  };
  return sl;
};

const long double *calculationdata::sitepostprob(){
  if(spp==NULL&&mixnum>1){
    spp=((Mixtreelikelihood *)ff)->sitepostprobs();
  };
  return spp;
};

void calculationdata::observedinformation(ostream& out){
  if(oi.sz==0){
    oi=ff->oi(x);
  };
  out<<oi;
};

void calculationdata::observedinformationinverse(ostream& out){
  if(oii.sz==0){
    if(oi.sz==0){
      oi=ff->oi(x);
    };
    oii=oi.inverse();
  };
  out<<oii;
};

